// shameless copy of a lock on script, slightly edited
// ----------------------------------------------
local s_closestdist
local s_closestmo
local s_sourceplayer
local function LockOnFoundObject(pmobj, mo)
	//Prevent targeting Battle's target dummy since we can target players anyways
	if (pcall(function() local v = _G["MT_TARGETDUMMY"] end, "MT_TARGETDUMMY")
	and mo.type == _G["MT_TARGETDUMMY"]) then return end
	
	if (pcall(function() local v = _G["MT_TNTBARREL"] end, "MT_TNTBARREL") // don't target TNT that would be bad
	and mo.type == _G["MT_TNTBARREL"]) then return end
	
	if mo.flags & (MF_NOCLIPTHING|MF_NOCLIP) or mo.flags2 & MF2_FRET
	or not mo.health or mo == pmobj or mo == s_sourceplayer.mo
	or ((twodlevel or pmobj.flags2 & MF2_TWOD) and abs(pmobj.y-mo.y) > pmobj.radius)
	return end

	if mo.player
		if mo.player.spectator
			return
		elseif P_PlayerInPain(mo.player) or mo.player.powers[pw_flashing]
			return
		elseif gametyperules&GTR_FRIENDLY and not CV_FindVar("friendlyfire").value
			return
		elseif G_GametypeHasTeams() and mo.player.ctfteam == s_sourceplayer.ctfteam
			return
		elseif G_TagGametype() and (mo.player.pflags & PF_TAGIT) == (s_sourceplayer.pflags & PF_TAGIT)
			return
		end
	elseif mo.flags & (MF_MONITOR) and (G_RingSlingerGametype() or (CBW_Battle and CBW_Battle.BattleGametype()))
		return
	elseif (!((mo.flags & (MF_ENEMY|MF_BOSS) and (mo.flags & MF_SHOOTABLE))) == !(mo.flags2 & MF2_INVERTAIMABLE)) // allows if it has the flags desired XOR it has the invert aimable flag
		return // not a valid target
	end
	
	// Needs to be closer!
	local adist = P_AproxDistance(P_AproxDistance(pmobj.x-mo.x, pmobj.y-mo.y), pmobj.z-mo.z)
	if(adist > s_closestdist)
		return
	end
	
	local an = R_PointToAngle2(pmobj.x, pmobj.y, mo.x, mo.y) - pmobj.angle
	if((AngleFixed(an) > 45*FRACUNIT) and(AngleFixed(an) < 285*FRACUNIT))	// behind back
		or not(P_CheckSight(pmobj, mo))		// out of sight
		return
	end
	
	s_closestmo = mo
	s_closestdist = adist
end

rawset(_G, "LO_LockOnToEnemies", function(mobj, player, dist)
	s_closestdist = dist+1
	s_closestmo = nil
	s_sourceplayer = player
	// Search the blockmap for targetable objects!
	searchBlockmap("objects", LockOnFoundObject, mobj, mobj.x-dist, mobj.x+dist, mobj.y-dist, mobj.y+dist)
	// Check if it was in range!
	if(s_closestmo and s_closestmo.valid)
		and(P_AproxDistance(P_AproxDistance(mobj.x-s_closestmo.x, mobj.y-s_closestmo.y), mobj.z-s_closestmo.z) > FixedMul(dist, mobj.scale))
		s_closestmo = nil	 // out of range
	end
	return s_closestmo
end)
